# coding: utf-8

"""
    Wavefront REST API Documentation

    <p>The REST API enables you to interact with the Wavefront service by using standard REST API tools. You can use the REST API to automate commonly executed operations, for example to tag sources automatically.</p><p>When you make REST API calls outside the REST API documentation UI, to authenticate to the service, you must use an API token associated with a user account or a service account. For information on how to get the API token and examples, see <a href=\"http://docs.wavefront.com/using_wavefront_api.html\">Use the Wavefront REST API.</a></p>  # noqa: E501

    OpenAPI spec version: v2
    Contact: chitimba@wavefront.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from wavefront_api_client.configuration import Configuration


class AppSearchFilter(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'filter_type': 'str',
        'values': 'AppSearchFilterValue'
    }

    attribute_map = {
        'filter_type': 'filterType',
        'values': 'values'
    }

    def __init__(self, filter_type=None, values=None, _configuration=None):  # noqa: E501
        """AppSearchFilter - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._filter_type = None
        self._values = None
        self.discriminator = None

        if filter_type is not None:
            self.filter_type = filter_type
        if values is not None:
            self.values = values

    @property
    def filter_type(self):
        """Gets the filter_type of this AppSearchFilter.  # noqa: E501


        :return: The filter_type of this AppSearchFilter.  # noqa: E501
        :rtype: str
        """
        return self._filter_type

    @filter_type.setter
    def filter_type(self, filter_type):
        """Sets the filter_type of this AppSearchFilter.


        :param filter_type: The filter_type of this AppSearchFilter.  # noqa: E501
        :type: str
        """
        allowed_values = ["OPERATION", "TAG", "RAW_TAG", "SPAN_LOG", "DURATION", "SPAN_DURATION", "LIMIT", "ERROR", "TRACE_ID", "SOURCE"]  # noqa: E501
        if (self._configuration.client_side_validation and
                filter_type not in allowed_values):
            raise ValueError(
                "Invalid value for `filter_type` ({0}), must be one of {1}"  # noqa: E501
                .format(filter_type, allowed_values)
            )

        self._filter_type = filter_type

    @property
    def values(self):
        """Gets the values of this AppSearchFilter.  # noqa: E501


        :return: The values of this AppSearchFilter.  # noqa: E501
        :rtype: AppSearchFilterValue
        """
        return self._values

    @values.setter
    def values(self, values):
        """Sets the values of this AppSearchFilter.


        :param values: The values of this AppSearchFilter.  # noqa: E501
        :type: AppSearchFilterValue
        """

        self._values = values

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(AppSearchFilter, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AppSearchFilter):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AppSearchFilter):
            return True

        return self.to_dict() != other.to_dict()
